import _ from 'lodash';

function _isLoading(state) {
  for (var topic in state.topics) {
    if (state.topics[topic] > 0) {
      return true;
    }
  }

  return false;
}

export default {
  state: {
    topics: {}
  },
  getters: {
    isLoading (state) {
      return _isLoading(state);
    },
    isLoadingFor: (state) => (searchTopics) => {
      const searchIsArray = _.isArray(searchTopics);

      if (!searchIsArray && state.topics[searchTopics] && state.topics[searchTopics] > 0) {
        return true;
      } else {
        var _searchTopics;

        if (!searchIsArray) {
          _searchTopics = [searchTopics.split('.')];
        } else {
          _searchTopics = searchTopics.map(t => t.split('.'));
        }

        for (var topic in state.topics) {
          const topicParts = topic.split('.');

          for (var i = 0; i < _searchTopics.length; i++) {
            if (topicParts.length ===  _searchTopics[i].length) {
              for (var j = 0; j < topicParts.length; j++) {
                if (_searchTopics[i][j] !== '*' && _searchTopics[i][j] !== topicParts[j]) {
                  break;
                }

                // We are at the last topic part and have not been rejected yet.
                // Check if there are active loaders for this topic.
                if (j === topicParts.length - 1 && state.topics[topic] > 0) {
                  return true;
                }
              }
            }
          }
        }

        return false;
      }
    }
  },
  mutations: {
    startLoading (state, payload) {
      if (!state.topics[payload]) {
        state.topics = { ...state.topics, [payload]: 0 }
      }
      state.topics[payload]++;
    },
    endLoading (state, payload) {
      state.topics[payload]--;
      if (state.topics[payload] === 0) {
        state.topics = _.omit(state.topics, [payload]);
      }
    }
  }
}
